VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CMember"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private mdParameters As NParameters
Private mdStrSignature As String
Private mdType As MemberTypeConstants
Private mdStrUserMemID As String
Private mdStrMemberFlags As String
Private mdStrDescription As String

Public Enum MemberTypeConstants
    mbrFunction = 1
    mbrSub = 2
    mbrPropertyRW = 3
    mbrPropertyR = 4
    mbrPropertyW = 5
    mbrEvent = 6
End Enum


Private Sub Class_Initialize()
On Error GoTo hell
    Set mdParameters = New NParameters
    Exit Sub
hell:
End Sub
Friend Function ConstructObject(ByVal sSignature As String, ByVal iType As MemberTypeConstants) As Boolean
On Error GoTo hell
    If sSignature = "" Then GoTo hell
    mdStrSignature = sSignature
    mdType = iType
    mdParameters.ConstructObject Me
    ConstructObject = True
    Exit Function
hell:
End Function


Public Property Get Parameters() As NParameters
On Error GoTo hell
    Set Parameters = mdParameters
    Exit Property
hell:
End Property
Public Property Get Signature() As String
On Error GoTo hell
    Signature = mdStrSignature
    Exit Property
hell:
End Property
Public Property Get Name() As String
Attribute Name.VB_UserMemId = 0
On Error GoTo hell
    Dim iBeforeName As Integer, iAfterName As Integer
    Select Case Me.MemberType
        Case 1: iBeforeName = 9
        Case 2: iBeforeName = 4
        Case 6: iBeforeName = 6
        Case Else: iBeforeName = 9
    End Select
    iAfterName = InStr(iBeforeName + 1, mdStrSignature, "(", vbTextCompare)
    Name = Mid(mdStrSignature, iBeforeName + 1, iAfterName - iBeforeName - 1)
    Exit Property
hell:
End Property
Public Property Get MemberType() As MemberTypeConstants
On Error GoTo hell
    MemberType = mdType
    Exit Property
hell:
End Property
Friend Property Let MemberType(iMemberType As MemberTypeConstants)
On Error GoTo hell
    mdType = iMemberType
    Exit Property
hell:
End Property
Public Property Get ReturnTypeName() As String
On Error GoTo hell
    If mdType = mbrSub Or mdType = mbrEvent Then GoTo hell
    Dim iLastBlank As Integer, sReturn As String
    iLastBlank = InStrRev(mdStrSignature, " ", -1, vbTextCompare)
    sReturn = Mid(mdStrSignature, iLastBlank + 1)
    ReturnTypeName = Trim(sReturn)
    Exit Property
hell:
End Property
Public Property Get UserMemID() As String
On Error GoTo hell
    UserMemID = mdStrUserMemID
    Exit Property
hell:
End Property
Friend Property Let UserMemID(sUserMemID As String)
On Error GoTo hell
    mdStrUserMemID = sUserMemID
    Exit Property
hell:
End Property
Public Property Get MemberFlags() As String
On Error GoTo hell
    MemberFlags = mdStrMemberFlags
    Exit Property
hell:
End Property
Friend Property Let MemberFlags(strMemberFlags As String)
On Error GoTo hell
    mdStrMemberFlags = strMemberFlags
    Exit Property
hell:
End Property
Public Property Get Description() As String
On Error GoTo hell
    Description = mdStrDescription
    Exit Property
hell:
End Property
Friend Property Let Description(strDescription As String)
On Error GoTo hell
    mdStrDescription = strDescription
    Exit Property
hell:
End Property


