VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CParameter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private mdStrSignature As String

Public Enum ArgModeConstants
    prmByVal = 1
    prmByRef = 2
End Enum


Friend Function ConstructObject(ByVal sSig As String) As Boolean
On Error GoTo hell
    If sSig = "" Then GoTo hell
    mdStrSignature = sSig
    ConstructObject = True
    Exit Function
hell:
End Function


Public Property Get Signature() As String
On Error GoTo hell
    Signature = mdStrSignature
    Exit Property
hell:
End Property
Public Property Get Name() As String
Attribute Name.VB_UserMemId = 0
On Error GoTo hell
    Dim lst As New NList, li As CListItem
    lst.FromString mdStrSignature, " "
    For Each li In lst
        If StrComp(li.Item, "ByVal", vbTextCompare) <> 0 Then
            If StrComp(li.Item, "ByRef", vbTextCompare) <> 0 Then
                If StrComp(li.Item, "Optional", vbTextCompare) <> 0 Then
                    If StrComp(li.Item, "ParamArray", vbTextCompare) <> 0 Then
                        Name = li.Item
                        Exit Property
                    End If
                End If
            End If
        End If
    Next li
    Exit Property
hell:
End Property
Public Property Get TypeName() As String
On Error GoTo hell
    Dim iAs As Integer, iEqualsDefault As Integer
    iAs = InStr(1, mdStrSignature, " As ", vbTextCompare)
    If iAs Then
                iEqualsDefault = InStr(1, TypeName, "=")
                If iEqualsDefault Then
                            TypeName = Mid(mdStrSignature, iAs + 4, iEqualsDefault - iAs - 1)
                    Else
                            TypeName = Mid(mdStrSignature, iAs + 4)
                End If
                TypeName = Trim(TypeName)
    End If
    Exit Property
hell:
End Property
Public Property Get DefaultValue() As String
On Error GoTo hell
    Dim iEqualsDefault As Integer
    iEqualsDefault = InStr(1, mdStrSignature, "=")
    If iEqualsDefault Then
        DefaultValue = Mid(mdStrSignature, iEqualsDefault + 1)
        DefaultValue = Trim(DefaultValue)
    End If
    Exit Property
hell:
End Property
Public Property Get IsOptional() As Boolean
On Error GoTo hell
    If StrComp(Left(mdStrSignature, 8), "Optional", vbTextCompare) = 0 Then
        IsOptional = True
    End If
    Exit Property
hell:
End Property
Public Property Get IsParamArray() As Boolean
On Error GoTo hell
    If StrComp(Left(mdStrSignature, 10), "ParamArray", vbTextCompare) = 0 Then
        IsParamArray = True
    End If
    Exit Property
hell:
End Property
Public Property Get Mode() As ArgModeConstants
On Error GoTo hell
    If InStr(1, mdStrSignature, "ByVal", vbTextCompare) > 0 Then
                Mode = prmByVal
        Else:   Mode = prmByRef
    End If
    Exit Property
hell:
End Property

