VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "NStructures"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' ***************************************************************************************
' Deklarationen
' ***************************************************************************************

Private mdCol As Collection
Private mdParent As CProject


' ***************************************************************************************
' Start
' ***************************************************************************************
Private Sub Class_Initialize()
On Error GoTo hell
    Set mdCol = New Collection
    Exit Sub
hell:
End Sub
Friend Function ConstructObject(ByVal myParent As CProject) As Boolean
On Error GoTo hell
    Set mdParent = myParent
    ConstructObject = True
    Exit Function
hell:
End Function
Public Function Refresh() As Boolean
On Error GoTo hell
    Do While mdCol.Count
        mdCol.Remove 1
    Loop
    ReadData
    Exit Function
hell:
End Function


' ***************************************************************************************
' Typische Eigenschaften und Methoden
' ***************************************************************************************
Public Property Get Count() As Long
On Error GoTo hell
    Count = mdCol.Count
    Exit Property
hell:
End Property
Public Property Get Item(ByVal vIndex As Variant) As CStructure   ' Default
Attribute Item.VB_UserMemId = 0
On Error GoTo hell
    Set Item = mdCol(vIndex)
    Exit Property
hell:
End Property
Public Function NewEnum() As IEnumVARIANT ' -4; versteckt
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
On Error GoTo hell
    Set NewEnum = mdCol.[_NewEnum]
    Exit Function
hell:
End Function
Public Sub Clear()
On Error GoTo hell
    Do While mdCol.Count
        mdCol.Remove 1
    Loop
    Set mdParent = Nothing
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Spezielle Eigenschaften und Methoden
' ***************************************************************************************
Public Property Get Parent() As CProject
On Error GoTo hell
    Set Parent = mdParent
    Exit Property
hell:
End Property


' ***************************************************************************************
' Untersttzung
' ***************************************************************************************
Private Function ReadData()
On Error GoTo hell
    Dim Classes As NClasses, Class As CClass, lst As NList, lstUDT As NList, i As Integer, j As Integer, sLineNext As String, sLine As String, fBegun As Boolean, iComment As Integer, strct As CStructure
    Set Classes = Me.Parent.Classes
    If Classes.Count = 0 Then Classes.Refresh
    For Each Class In Classes
        Set lst = New NList
        lst.FromFile Class.File
        For i = 1 To lst.Count
            sLine = lst(i).Item
            If fBegun = False Then
                        If StrComp(Left(sLine, 20), "Attribute VB_Exposed", vbTextCompare) = 0 Then
                            fBegun = True
                        End If
                Else
                        If StrComp(Left(sLine, 11), "Public Type", vbTextCompare) = 0 Then
                            ' Kommentar am Ende?
                            iComment = InStrRev(sLine, "'")
                            If iComment Then
                                sLine = Mid(sLine, 1, iComment - 1)
                                sLine = Trim(sLine)
                            End If
                            ' Weiterlesen bis Ende
                            For j = i + 1 To lst.Count
                                sLineNext = lst(j).Item
                                If StrComp(Left(sLineNext, 8), "End Type", vbTextCompare) = 0 Then
                                    ' Erstellen
                                    Set lstUDT = lst.Copy(i, j)
                                    Set strct = New CStructure
                                    strct.ConstructObject Mid(sLine, 13), lstUDT
                                    ' Anfgen
                                    mdCol.Add strct
                                    ' Weiterspringen; raus
                                    i = j
                                    Exit For
                                End If
                            Next j
                        End If
            End If
        Next i
    Next Class
    GoTo finally
hell:
finally:
End Function

