VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private mdMembers As NMembers
Private mdStrName As String
Private mdStrFile As String
Private mdInstancing As InstancingConstants
Private mdStrDescription As String

Public Enum InstancingConstants
    clsPrivate = 1
    clsPublicNotCreatable = 2
    clsSingleUse = 3
    clsGlobalSingleUse = 4
    clsMultiUse = 5
    clsGlobalMultiUse = 6
End Enum


Private Sub Class_Initialize()
On Error GoTo hell
    Set mdMembers = New NMembers
    Exit Sub
hell:
End Sub
Friend Function ConstructObject(ByVal sName As String, ByVal sFile As String) As Boolean
On Error GoTo hell
    If sName = "" Or sFile = "" Then GoTo hell
    mdStrName = sName
    mdStrFile = sFile
    mdMembers.ConstructObject Me
    ConstructObject = True
    Exit Function
hell:
End Function


Public Function Refresh() As Boolean
On Error GoTo hell
    ReadInstancingAndDescription
    Refresh = True
    Exit Function
hell:
End Function
Private Sub ReadInstancingAndDescription()
On Error GoTo hell
    Dim lst As New NList, sLine As String, i As Integer, iEq As Integer
    lst.FromFile mdStrFile
    Dim fExposed As Boolean, fCreatable As Boolean, fMultiUse As Boolean, fGlobalNameSpace As Boolean
    For i = 1 To IIf(lst.Count > 20, 20, lst.Count)
        sLine = lst(i).Item
        ' ffentlich oder Privat?
        If StrComp(Left(sLine, 20), "Attribute VB_Exposed", vbTextCompare) = 0 Then
            If StrComp(Mid(sLine, 24, 4), "True", vbTextCompare) = 0 Then
                fExposed = True
            End If
        End If
        ' Erstellbar?
        If StrComp(Left(sLine, 22), "Attribute VB_Creatable", vbTextCompare) = 0 Then
            If StrComp(Mid(sLine, 26, 4), "True", vbTextCompare) = 0 Then
                fCreatable = True
            End If
        End If
        ' Global?
        If StrComp(Left(sLine, 28), "Attribute VB_GlobalNameSpace", vbTextCompare) = 0 Then
            If StrComp(Mid(sLine, 32, 4), "True", vbTextCompare) = 0 Then
                fGlobalNameSpace = True
            End If
        End If
        ' Multi oder Single?
        If InStr(1, sLine, "MultiUse", vbTextCompare) > 0 Then
            If InStr(1, sLine, "-1", vbTextCompare) > 0 Then
                fMultiUse = True
            End If
        End If
        ' Beschreibung
        If StrComp(Left(sLine, 24), "Attribute VB_Description", vbTextCompare) = 0 Then
            iEq = InStr(1, sLine, "=")
            If iEq Then
                mdStrDescription = Trim(Mid(sLine, iEq + 1))
                mdStrDescription = Replace(mdStrDescription, Chr$(34), "", , , vbTextCompare)
            End If
        End If
    Next i
    If fExposed = False Then
                        mdInstancing = clsPrivate
        ElseIf fCreatable = False Then
                        mdInstancing = clsPublicNotCreatable
        ElseIf fGlobalNameSpace = False Then
            If fMultiUse = True Then
                        mdInstancing = clsMultiUse
                Else
                        mdInstancing = clsSingleUse
            End If
        ElseIf fGlobalNameSpace = True Then
            If fMultiUse = True Then
                        mdInstancing = clsGlobalMultiUse
                Else
                        mdInstancing = clsGlobalSingleUse
            End If
        Else
                        mdInstancing = 0    ' Fehler
    End If
    Exit Sub
hell:
End Sub


Public Property Get Members() As NMembers
On Error GoTo hell
    Set Members = mdMembers
    Exit Property
hell:
End Property
Public Property Get Name() As String ' Default
Attribute Name.VB_UserMemId = 0
On Error GoTo hell
    Name = mdStrName
    Exit Property
hell:
End Property
Public Property Get File() As String
On Error GoTo hell
    File = mdStrFile
    Exit Property
hell:
End Property
Public Property Get Instancing() As InstancingConstants
On Error GoTo hell
    Instancing = mdInstancing
    Exit Property
hell:
End Property
Public Property Get Description() As String
On Error GoTo hell
    Description = mdStrDescription
    Exit Property
hell:
End Property

