VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "NMembers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' ***************************************************************************************
' Deklarationen
' ***************************************************************************************

Private mdCol As Collection
Private mdParent As CClass


' ***************************************************************************************
' Start
' ***************************************************************************************
Private Sub Class_Initialize()
On Error GoTo hell
    Set mdCol = New Collection
    Exit Sub
hell:
End Sub
Friend Function ConstructObject(ByVal myParent As CClass) As Boolean
On Error GoTo hell
    Set mdParent = myParent
    ConstructObject = True
    Exit Function
hell:
End Function
Public Function Refresh() As Boolean
On Error GoTo hell
    Do While mdCol.Count
        mdCol.Remove 1
    Loop
    ReadData
    Refresh = True
    Exit Function
hell:
End Function


' ***************************************************************************************
' Typische Eigenschaften und Methoden
' ***************************************************************************************
Public Property Get Count() As Long
On Error GoTo hell
    Count = mdCol.Count
    Exit Property
hell:
End Property
Public Property Get Item(ByVal vIndex As Variant) As CMember ' Default
Attribute Item.VB_UserMemId = 0
On Error GoTo hell
    Set Item = mdCol(vIndex)
    Exit Property
hell:
End Property
Public Function NewEnum() As IEnumVARIANT ' -4; versteckt
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
On Error GoTo hell
    Set NewEnum = mdCol.[_NewEnum]
    Exit Function
hell:
End Function
Public Sub Clear()
On Error GoTo hell
    Do While mdCol.Count
        mdCol.Remove 1
    Loop
    Set mdParent = Nothing
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Spezielle Eigenschaften und Methoden
' ***************************************************************************************
Public Property Get Parent() As CClass
On Error GoTo hell
    Set Parent = mdParent
    Exit Property
hell:
End Property


' ***************************************************************************************
' Untersttzung
' ***************************************************************************************
Private Sub ReadData()
On Error GoTo hell
    Dim lst As NList, i As Integer, fBegun As Boolean
    Dim sLine As String, j As Integer, sExt As String, iComment As Integer
    Dim sAttrLine As String, iAttrPoint As Integer, iAttrEquals As Integer, sUserMemID As String, sMemberFlags As String, sDescription As String
    Dim mbr As CMember, iType As MemberTypeConstants
    Dim iAfterPubVarName As Integer, iMemberExists
    Set lst = New NList
    lst.FromFile Me.Parent.File
    ' Einlesen (Eigenschaften noch doppelt; PubVars; nur Signaturen)
    For i = 1 To lst.Count
        sLine = lst(i).Item
        If fBegun = False Then
                    ' Modulanfang erkennen
                    If StrComp(Left(sLine, 20), "Attribute VB_Exposed", vbTextCompare) = 0 Then
                        fBegun = True
                    End If
            Else
                    ' Zeilen erkennen
                    If StrComp(Left(sLine, 15), "Public Function", vbTextCompare) = 0 Then
                            iType = mbrFunction
                        ElseIf StrComp(Left(sLine, 10), "Public Sub", vbTextCompare) = 0 Then
                            iType = mbrSub
                        ElseIf StrComp(Left(sLine, 12), "Public Event", vbTextCompare) = 0 Then
                            iType = mbrEvent
                        ElseIf StrComp(Left(sLine, 15), "Public Property", vbTextCompare) = 0 Then
                            iType = -1
                        ElseIf StrComp(Left(sLine, 6), "Public", vbTextCompare) = 0 Then
                            If StrComp(Left(sLine, 11), "Public Type", vbTextCompare) <> 0 Then
                                If StrComp(Left(sLine, 11), "Public Enum", vbTextCompare) <> 0 Then
                                    iType = -2
                                End If
                            End If
                    End If
                    ' Was gefunden?
                    If iType <> 0 Then
                        ' Kommentar am Ende?
                        iComment = InStrRev(sLine, "'")
                        If iComment Then
                            sLine = Mid(sLine, 1, iComment - 1)
                            sLine = Trim(sLine)
                        End If
                        ' Verlngerung?
                        sExt = Right(sLine, 1)
                        Do While sExt = "_"
                            j = j + 1
                            sLine = Mid(sLine, 1, Len(sLine) - 2)
                            sLine = sLine & " " & Trim(lst(i + j))
                            sExt = Right(lst(i + j), 1)
                        Loop
                        ' Attribute?
                        j = 1
                        sAttrLine = lst(i + j)
                        Do While StrComp(Left(sAttrLine, 9), "Attribute", vbTextCompare) = 0
                            iAttrPoint = InStr(1, sAttrLine, ".")
                            If iAttrPoint Then
                                iAttrEquals = InStr(iAttrPoint, sAttrLine, "=")
                                If iAttrEquals Then
                                    If StrComp(Mid(sAttrLine, iAttrPoint + 1, 15), "VB_VarUserMemId", vbTextCompare) = 0 Then
                                            sUserMemID = Trim(Mid(sAttrLine, iAttrEquals + 1))
                                        ElseIf StrComp(Mid(sAttrLine, iAttrPoint + 1, 12), "VB_UserMemId", vbTextCompare) = 0 Then
                                            sUserMemID = Trim(Mid(sAttrLine, iAttrEquals + 1))
                                        ElseIf StrComp(Mid(sAttrLine, iAttrPoint + 1, 14), "VB_MemberFlags", vbTextCompare) = 0 Then
                                            sMemberFlags = Trim(Mid(sAttrLine, iAttrEquals + 1))
                                            sMemberFlags = Replace(sMemberFlags, Chr$(34), "")
                                        ElseIf StrComp(Mid(sAttrLine, iAttrPoint + 1, 14), "VB_Description", vbTextCompare) = 0 Then
                                            sDescription = Trim(Mid(sAttrLine, iAttrEquals + 1))
                                            sDescription = Replace(sDescription, Chr$(34), "")
                                    End If
                                End If
                            End If
                            j = j + 1
                            sAttrLine = lst(i + j)
                        Loop
                        ' Modifaxe wech
                        sLine = Mid(sLine, 8)
                        ' Auswerten
                        Select Case iType
                            Case mbrFunction, mbrSub, mbrEvent
                                Set mbr = New CMember
                                mbr.ConstructObject sLine, iType
                                If sMemberFlags <> "" Then mbr.MemberFlags = sMemberFlags
                                If sUserMemID <> "" Then mbr.UserMemID = sUserMemID
                                If sDescription <> "" Then mbr.Description = sDescription
                                mdCol.Add mbr
                            Case -1 ' PropPut oder PropGet
                                iType = GetPropHalfType(sLine)
                                sLine = GetPropSignature(sLine)
                                iMemberExists = MemberExists(sLine)
                                If iMemberExists Then
                                            Set mbr = mdCol(iMemberExists)
                                            mbr.MemberType = mbrPropertyRW
                                            If sMemberFlags <> "" Then mbr.MemberFlags = sMemberFlags
                                            If sUserMemID <> "" Then mbr.UserMemID = sUserMemID
                                            If sDescription <> "" Then mbr.Description = sDescription
                                    Else
                                            Set mbr = New CMember
                                            mbr.ConstructObject sLine, iType
                                            If sMemberFlags <> "" Then mbr.MemberFlags = sMemberFlags
                                            If sUserMemID <> "" Then mbr.UserMemID = sUserMemID
                                            If sDescription <> "" Then mbr.Description = sDescription
                                            mdCol.Add mbr
                                End If
                            Case -2 ' ff. Var.
                                sLine = Trim(sLine)
                                iAfterPubVarName = InStr(1, sLine, " ")
                                sLine = Left(sLine, iAfterPubVarName - 1) & "()" & Mid(sLine, iAfterPubVarName)
                                sLine = Trim(sLine)
                                sLine = "Property " & sLine
                                Set mbr = New CMember
                                mbr.ConstructObject sLine, mbrPropertyRW
                                If sMemberFlags <> "" Then mbr.MemberFlags = sMemberFlags
                                If sUserMemID <> "" Then mbr.UserMemID = sUserMemID
                                If sDescription <> "" Then mbr.Description = sDescription
                                mdCol.Add mbr
                        End Select ' Case iType
                    End If ' iType <> 0
                    ' zurcksetzen
                    sMemberFlags = ""
                    sUserMemID = ""
                    sDescription = ""
                    iType = 0
                    j = 0
        End If ' fBegun
    Next i
    GoTo finally
hell:
finally:
End Sub
Private Function GetPropSignature(ByVal sLine As String) As String
On Error GoTo hell
    If StrComp(Mid(sLine, 10, 3), "Get", vbTextCompare) = 0 Then
                GetPropSignature = Mid(sLine, 1, 8) & " " & Mid(sLine, 14)
        Else
                Dim iLastAs As Integer, iLastParamSep As Integer, sLastParameter As String, sAllButReturn As String, sReturn As String
                ' Letztes Komma bzw. ffnende Klammer
                iLastParamSep = InStrRev(sLine, ",")
                If iLastParamSep = 0 Then
                    iLastParamSep = InStrRev(sLine, "(")
                End If
                ' Alles auer Rckgabewert
                sAllButReturn = Mid(sLine, 1, iLastParamSep)
                If Right(sAllButReturn, 1) = "," Then
                    sAllButReturn = Mid(sAllButReturn, 1, Len(sAllButReturn) - 1)
                End If
                sAllButReturn = sAllButReturn & ")"
                sAllButReturn = Mid(sAllButReturn, 1, 8) & " " & Mid(sAllButReturn, 14)
                ' Rckgabewert
                sLastParameter = Mid(sLine, iLastParamSep + 1, Len(sLine) - iLastParamSep - 1)
                sLastParameter = Trim(sLastParameter)
                iLastAs = InStrRev(sLastParameter, " As ", -1, vbTextCompare)
                sReturn = Mid(sLastParameter, iLastAs)
                sReturn = Trim(sReturn)
                GetPropSignature = sAllButReturn & " " & sReturn
    End If
    Exit Function
hell:
End Function
Private Function GetPropHalfType(ByVal sLine As String) As MemberTypeConstants
On Error GoTo hell
    If StrComp(Mid(sLine, 10, 3), "Get", vbTextCompare) = 0 Then
                GetPropHalfType = mbrPropertyR
        Else
                GetPropHalfType = mbrPropertyW
    End If
    Exit Function
hell:
End Function
Private Function MemberExists(ByVal sLine As String) As Integer
On Error GoTo hell
    Dim i As Integer
    For i = 1 To mdCol.Count
        If StrComp(mdCol(i).Signature, sLine, vbTextCompare) = 0 Then
            MemberExists = i
            Exit For
        End If
    Next i
    Exit Function
hell:
End Function

